#ifndef RecordingProtocol_h
#define RecordingProtocol_h
#pragma interface

#include "protocol.h"

class RecordingProtocol 
// A RecordingProtocol session.  This object listens to the mic and gives
// back a pattern suited for your recognizer.  It can also give
// the underlying sample.
{
public:
  RecordingProtocol ();
  virtual ~RecordingProtocol();
  virtual void start();

  const class pattern& getPattern() { return *pat_; }
  const class sample& sample()      { return *sample_; }
  
private:
  class speechstream* speech_;
  class sample* sample_;
  class pattern* pat_;
};

#endif
